main/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('communication/', include('communication.urls')),
    path('', include('items.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

users/urls.py
from django.urls import path, include
from .views import RegistrationView,Login,PasswordResetView,ProfileDetailView,ProfileUpdateView,PasswordChangeView
from django.urls import reverse_lazy
from django.contrib.auth.views import LogoutView
app_name = 'users'
urlpatterns = [
    path('register/', RegistrationView.as_view(), name='register' ),
    path('login/', Login.as_view(), name='login' ),
    path('logout/', LogoutView.as_view(next_page = "/user/logged_out/"), name='logout'),
    path('logged_out/', LogoutView.as_view(next_page=None,template_name="user/logged_out.html"), name='logged_out'),
    path('reset_password/', PasswordResetView.as_view(), name='reset_password' ),
    path('profile/<int:pk>/', ProfileDetailView.as_view(), name='user_profile' ),
    path('profile/me/', ProfileDetailView.as_view(is_me=True), name='me' ),
    path('profile/edit/', ProfileUpdateView.as_view(), name='profile_update' ),
    path('change_password/', PasswordChangeView.as_view(success_url="/user/password_changed/"), name='password_change' ),
    path('password_changed/', PasswordChangeView.as_view(template_name="user/password_changed.html"), name='password_changed' ),
]

items/models.py
from django.db import models
from django.conf import settings
from django.utils.text import slugify


class Category(models.Model):
    COLORS = (
        ('S', 'success'),
        ('P', 'primary'),
        ('I', 'info'),
        ('W', 'warning'),
        ('D', 'danger'),
        ('A', 'dark'),
        ('E', 'secondary'),
        ('L', 'light')
    )

    ICONS = (
        ('T', 'mobile-alt'),
        ('B', 'book'),
        ('M', 'music'),
        ('C', 'car'),
        ('H', 'home'),
        ('A', 'basketball-ball'),
        ('E', 'headphones'),
        ('D', 'baby-carriage'),
    )
    name = models.CharField(max_length=50)
    color = models.CharField(max_length=1, choices=COLORS, default='P')
    icon = models.CharField(max_length=1, choices=ICONS, default='B')

    slug = models.SlugField(unique=True, null=True, blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        super(Category, self).save(*args, **kwargs)

    def __str__(self):
        return self.name    


class Item(models.Model):
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True, related_name='items')
    name = models.CharField(max_length=50)
    description = models.TextField(max_length=250)
    price = models.FloatField()
    picture = models.ImageField(upload_to='item_pictures/', default="item_pictures/default.jpg")
    is_available = models.BooleanField(default=True)
    created_at = models.DateField(auto_now_add=True)
    updated_at = models.DateField(auto_now=True)
    category = models.ForeignKey(Category, on_delete=models.DO_NOTHING, related_name='items')

    slug = models.SlugField(unique=True, null=True, blank=True)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        return super(Item, self).save(*args, **kwargs)
    def __str__(self):
        return self.name
    

class ItemRental(models.Model):
    item = models.ForeignKey(Item, on_delete=models.SET_NULL, null=True)
    hirer = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True)
    fulfilled = models.BooleanField(default=False)
    created = models.DateTimeField(auto_now_add=True)

templates/base.html
{% load static %}
<!DOCTYPE html>
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <title>Renten</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <script src="https://kit.fontawesome.com/58d516dd2f.js"></script>
        <link rel="stylesheet" type="text/css" href="{% static 'layout/css/bootstrap.min.css' %}">
        <link rel="stylesheet" type="text/css" href="{% static 'layout/css/styles.css' %}">
        </style>
    </head>
    <body>
        {% include 'navbar.html' %}

        {% block body %}
        {% endblock body %}
        
        <script src="{% static 'layout/js/jquery-3.4.1.slim.min.js' %}"></script>
        <script src="{% static 'layout/js/popper.min.js' %}"></script>
        <script src="{% static 'layout/js/bootstrap.min.js' %}"></script>
    </body>
</html>

templates/home.html
{% extends 'base.html' %}

{% block body %}
<div class="jumbotron jumbotron-fluid">
        <div class="container">
          <h1 class="display-4" style="color:white;">Renten</h1>
          {% if request.user.is_authenticated %}
          <a href="{% url 'item-create' %}" class="btn btn-success">Ürün Ekle</a>
          {% else %}
          <a href="{% url "users:register" %}" class="btn btn-info">Kayıt Ol</a><a href="" class="btn btn-success">Giriş Yap</a>
          {% endif %}
        </div>
  </div>
  <div class="container">
    <div class="row text-center">
      {%for category in items.all_categories%}
        <div class="col-1">
          <form action="{% url 'search_category' %}" method="GET">
            <button class="btn btn-{{category.get_color_display}} btn-circle btn-circle-lg m-1">
              <i class="fa fa-{{category.get_icon_display}}"></i>         
            </button>
            <span>{{category.name}}</span>
            <input type="hidden" value="{{category.name}}" name="q">
          </form>
        </div>
      {% endfor %}  
    </div>
    {% if items.is_search %}
      <br>
      <a class="btn btn-danger" href="{% url 'home' %}"><i class="fas fa-long-arrow-alt-left"></i> Aramayı sıfırla</a>
    {% endif %}
    <div class="row">
      <div class="col-3">
          <div class="dropdown" style="margin-top:2%;">
              <button class="btn btn-light dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                Fiyat
              </button>
              <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                <form method="GET" action="{% url 'search_price' %}">
                  <input type="number" placeholder="Min" step="0.01" min="0" id="minPrice" name="minPrice">
                  - <input type="number" placeholder="Max" step="0.01" min="0" id="maxPrice" name="maxPrice">
                  <input type="submit" value="submit" style="display: none;"/>
                </form>  
              </div>
            </div>
      </div>
      <div class="col-3">
          <div class="dropdown" style="margin-top:2%;">
              <button class="btn btn-light dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                Lokasyon
              </button>
              <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                <form method="GET" action="{% url 'search_location' %}">
                  <input type="text" placeholder="Lokasyon" id="location" name="location">
                  <input type="submit" value="submit" style="display: none;"/>
                </form>  
              </div>
            </div>
      </div>
    </div>
 
      {% if items.minimum and items.maximum %}
        <p>₺{{items.minimum}} - ₺{{items.maximum}}</p>
      {% endif %}
    <div class="row text-center" id="items-mainpage">
      {% for item in items.all_items %}
        <div class="col-3">
          <div class="card">
            <a href="{% url 'item-detail' item.slug %}"><img class="card-img-top" id="item-image" src="{{ item.picture.url }}" alt="Card image cap"></a>
            <div class="card-body">
              <h5 class="card-title" id="item-header"><a href="{% url 'item-detail' item.slug %}">{{item.name}}</a></h5>
              <p class="card-text" id="item-text">{{item.description|truncatewords:5}}...</p>
              <div class="row">
                <div class="col-6">
                  <p class="card-text">{{item.owner.location}}</p>
                </div>
                <div class="div col-6">
                    <p class="card-text"> ₺{{item.price}} </p>
                </div>
              </div>
            </div>
          </div>
        </div>
      {% endfor %}
    </div>
  </div>
  
{% endblock body %}

templates/navbar.html
<nav class="navbar navbar-expand-lg navbar-light bg-light">
  <a class="navbar-brand" href="/">Renten</a>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent"
    aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  <div class="collapse navbar-collapse" id="navbarSupportedContent">
    <ul class="navbar-nav mr-auto">
      <form class="form-inline" method="GET" action='{% url "search" %}'>
        <input class="form-control mr-sm-2" type="search" placeholder="Ara" aria-label="Search" name="q">
      </form>
    </ul>

    <ul class="navbar-nav ml-auto">
      {% if request.user.is_authenticated %}
      <li class="nav-item active">
        <a class="nav-link" href="{% url "users:me"  %}">{{request.user}}</a>
      </li>
      <li class="nav-item active">
        <a class="nav-link" href="{% url "users:logout" %}">Çıkış</a>
      </li>
      {% else %}
      <li class="nav-item active">
        <a class="nav-link" href="{% url "users:register" %}">Kayıt</a>
      </li>
      <li class="nav-item">
        <a class="nav-link active" href="{% url "users:login" %}">Giriş</a>
      </li>
      {% endif %}
    </ul>

  </div>
</nav>